/* @bopen.c - buffered file library
 */
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include "bopen.h"
#ifndef STANDARD
#include "zstand.h"
#endif

BFD BSTDIN = 0, BSTDOUT = 1, BSTDERR = 2;
FD zopen(char *path, Oflag oflag, Mode pmode);
#if !defined(linux) && !defined(sparc)
int open(char *path, Oflag oflag, Mode pmode);
#endif

Functionmap filebufmap = 
	{
	open, 
	close,
	read,
	write,
	lseek,
	};

BFD rbopen(char *path, Oflag oflag, Mode pmode)
	{
	return bopen(path, oflag, pmode, &filebufmap);
	}

BFD rbufferset(FD fd)
	{
	return bufferset(fd, &filebufmap);
	}

BFD rbset(FD fd)
	{
	return bset(fd, &filebufmap);
	}

int rbinit_stdfiles(void)
	{
	int rtn = 0;

	if ((BSTDIN = rbufferset(STDIN_FILENO)) < 0)
		rtn = -ERRNO;
	if ((BSTDOUT = rbufferset(STDOUT_FILENO)) < 0)
		rtn = -ERRNO;
	if ((BSTDERR = rbset(STDERR_FILENO)) < 0)
		rtn = -ERRNO;
	return rtn;
	}




